unit RecordsInOleVariantsU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
type
  PCustomRec = ^TCustomRec;
  TCustomRec = packed record
    AnIntField: Integer;
    ACharField: Char;
    AFloatField: Double;
  end;

function VariantToCustomRec(Data: OleVariant): TCustomRec;
var
  P: Pointer;
begin
  if VarType(Data) and varArray = 0 then
    raise EConvertError.Create('Variant does not contain an array');
  if VarArrayHighBound(Data, 1) -
     VarArrayLowBound(Data, 1) + 1 < SizeOf(TCustomRec) then
    raise EConvertError.Create('Variant array is too small for expected data');
  P := VarArrayLock(Data);
  Move(P^, Result, SizeOf(TCustomRec));
  VarArrayUnlock(Data)
end;

function CustomRecToVariant(Data: TCustomRec): Variant;
var
  P: Pointer;
begin
  Result := VarArrayCreate([1, SizeOf(TCustomRec)], varByte);
  P := VarArrayLock(Result);
  Move(Data, P^, SizeOf(TCustomRec));
  VarArrayUnlock(Result)
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  CR, CR2: TCustomRec;
  V: Variant;
begin
  CR.AnIntField := 57;
  CR.ACharField := 'z';
  CR.AFloatField := Pi;
  V := CustomRecToVariant(CR);
  CR2 := VariantToCustomRec(V);
  ShowMessageFmt(
    'The integer is %d, the character is "%s" and the float is %g',
    [CR2.AnIntField, CR2.ACharField, CR2.AFloatField])
end;

end.
